function varargout = GPlan(varargin)
% GPLAN M-file for GPlan.fig
%      GPLAN, by itself, creates a new GPLAN or raises the existing
%      singleton*.
%
%      H = GPLAN returns the handle to a new GPLAN or the handle to
%      the existing singleton*.
%
%      GPLAN('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in GPLAN.M with the given input arguments.
%
%      GPLAN('Property','Value',...) creates a new GPLAN or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before GPlan_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to GPlan_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Copyright 2002-2003 The MathWorks, Inc.

% Edit the above text to modify the response to help GPlan

% Last Modified by GUIDE v2.5 03-Oct-2005 12:01:48
% Written by A. McClung 04/13/05 - Stanford Univ.

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @GPlan_OpeningFcn, ...
                   'gui_OutputFcn',  @GPlan_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before GPlan is made visible.
function GPlan_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to GPlan (see VARARGIN)

% Choose default command line output for GPlan
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes GPlan wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = GPlan_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;



function PIFront_Callback(hObject, eventdata, handles)
% hObject    handle to PIF (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of PIF as text
%        str2double(get(hObject,'String')) returns contents of PIF as a double


% --- Executes during object creation, after setting all properties.
function PIFront_CreateFcn(hObject, eventdata, handles)
% hObject    handle to PIF (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function PIRear_Callback(hObject, eventdata, handles)
% hObject    handle to PIR (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of PIR as text
%        str2double(get(hObject,'String')) returns contents of PIR as a double


% --- Executes during object creation, after setting all properties.
function PIRear_CreateFcn(hObject, eventdata, handles)
% hObject    handle to PIR (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function DC_Callback(hObject, eventdata, handles)
% hObject    handle to DC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of DC as text
%        str2double(get(hObject,'String')) returns contents of DC as a double


% --- Executes during object creation, after setting all properties.
function DC_CreateFcn(hObject, eventdata, handles)
% hObject    handle to DC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in Calc.
function Calc_Callback(hObject, eventdata, handles)
% hObject    handle to Calc (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%Turn off the animation button
set(handles.AnimBut,'Value',0);
%Draw the new body and legs
%Reset the plot formatting
newplot(handles.BodyPlot);
cla(handles.BodyPlot);
set(handles.BodyPlot,'XColor','w')
set(handles.BodyPlot,'YColor','w')
set(handles.BodyPlot,'XTickLabel','')
set(handles.BodyPlot,'YTickLabel','')
bodyWidth=0.4;
bodyLength=0.6;
legRadius=0.08;
legSpace=1.7;
numLegs=6;
%Plot the body
hold(handles.BodyPlot,'on');
plot(handles.BodyPlot,[-bodyWidth/2 bodyWidth/2 bodyWidth/2 -bodyWidth/2 -bodyWidth/2 ],...
    [-bodyLength/2 -bodyLength/2 bodyLength/2 bodyLength/2 -bodyLength/2],'k')
%Plot the legs (legs must be in pairs, ie. even #)
for i=1:numLegs/2
    xpos=bodyWidth*legSpace/2;
    ypos=bodyLength/2-bodyLength*((i-1)/(numLegs/2-1));
    circle5(xpos,ypos,legRadius,'br',handles.BodyPlot);
    circle5(-xpos,ypos,legRadius,'br',handles.BodyPlot);
    h=text(xpos*1.5,ypos,[num2str(numLegs-i)]);
    set(h,'Parent',handles.BodyPlot);  %Hack to get labels in right window
    h=text(-xpos*1.6,ypos,[num2str(i-1)]);
    set(h,'Parent',handles.BodyPlot);
end
set(handles.BodyPlot,'XLim',[-1,1])
set(handles.BodyPlot,'YLim',[-1,1])
%Draw the new leg temporal maps
newplot(handles.LegTimePlot);
cla(handles.LegTimePlot);
set(handles.LegTimePlot,'XGrid','on');
set(handles.LegTimePlot,'YTickLabel','')
hold(handles.LegTimePlot,'on');
tempSpace=1/(numLegs+1);
DC=str2num(get(handles.DC,'String'));
PIF=str2num(get(handles.PIR,'String'));
PIR=str2num(get(handles.PIR,'String'));
PC=str2num(get(handles.PC,'String'));
c='rgbcmywk';
ylabelpos=0;
ylabeltext='';
%Calculate the phasing for front and rear legs
here(2)=0.5;                %Mid leg - phasings are relative to the middle leg
here(1)=mod(here(2)+PIF,1); %Front leg
here(3)=mod(here(2)-PIR,1); %Rear leg
%Calculate the phasing for contralateral legs
for i=4:6
    here(i)=mod(here(7-i)+PC,1);   %Adjusted for wrap around leg numbering
end
%Plot the top and bottom limits on temporal display and fill in w/colors
for i=1:numLegs
    bot=i*tempSpace/(numLegs+1)+(i-1)*tempSpace;
    top=i*tempSpace/(numLegs+1)+i*tempSpace;
    plot(handles.LegTimePlot,[0 1],[bot bot],'k');
    plot(handles.LegTimePlot,[0 1],[top top],'k');
    templeg=fill([0 1 1 0],[bot bot top top],[.67 .67 .67]);
    set(templeg,'FaceAlpha',.2);
    there(i)=here(i)+DC;
    j=2;                %There are no more waves, so the fill will be RED
    h=fill([here(i) there(i) there(i) here(i)],[bot bot top top],c(j));
    set(h,'FaceAlpha',.7);
    if there(i)>1
        there(i)=mod(there(i),1);
        h=fill([0 there(i) there(i) 0],[bot bot top top],c(j));
        set(h,'FaceAlpha',.7);
    end
    ylabelpos(i)=bot+tempSpace/2;
    ylabeltext=[ylabeltext; 'Leg #' num2str(i-1)];
end
set(handles.LegTimePlot,'XLim',[0,1])
set(handles.LegTimePlot,'YLim',[0,1])
set(handles.LegTimePlot,'YTick',ylabelpos)
set(handles.LegTimePlot,'YTickLabel',ylabeltext)


% --- Executes on button press in AnimBut.
function AnimBut_Callback(hObject, eventdata, handles)
% hObject    handle to AnimBut (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of AnimBut
speedConstant=10;
curtime=0;
timeBar=plot(handles.LegTimePlot,[0 0],[0 1],'k');
set(timeBar,'LineWidth',2);
speed=get(handles.SpeedSlider,'Value');
%Same basic constants as above
bodyWidth=0.4;
bodyLength=0.6;
legRadius=0.08;
legSpace=1.7;
numLegs=6;
tempSpace=1/(numLegs+1);
DC=str2num(get(handles.DC,'String'));
PIF=str2num(get(handles.PIR,'String'));
PIR=str2num(get(handles.PIR,'String'));
PC=str2num(get(handles.PC,'String'));
c='rgbcmywk';
%Draw the legs for animation
for i=1:numLegs/2
    xpos=bodyWidth*legSpace/2;
    ypos=bodyLength/2-bodyLength*((i-1)/(numLegs/2-1));
    Leg(numLegs+1-i)=circle5(xpos,ypos,legRadius,'br',handles.BodyPlot);
    Leg(i)=circle5(-xpos,ypos,legRadius,'br',handles.BodyPlot);
end
%Build up a temporal table for legs
%Calculate the phasing for front and rear legs
here(2)=0.5;                %Mid leg - phasings are relative to the middle leg
here(1)=mod(here(2)+PIF,1); %Front leg
here(3)=mod(here(2)-PIR,1); %Rear leg
%Calculate the phasing for contralateral legs
for i=4:6
    here(i)=mod(here(7-i)+PC,1);   %Adjusted for wrap around leg numbering
end
for i=1:numLegs
    there(i)=here(i)+DC;
    if there(i)>1
        there(i)=mod(there(i),1);
    end
end
%Animate the plots
while get(hObject,'Value')==1
    speed=get(handles.SpeedSlider,'Value');
    curtime=mod(curtime+speed/speedConstant,1);
    set(timeBar,'XData',[curtime curtime]);
    j=2;                %There are no more waves, so the fill will be RED
    for i=1:numLegs
        LegActive(i)=0;
        if (((curtime<there(i))&(there(i)<here(i))) | ... %For the front end
                ((curtime>here(i))&(curtime<there(i))) | ... %For the middle
                ((here(i)>there(i))&(curtime>here(i)))) %For the tail end
            set(Leg(i),'Color',c(j),'LineWidth',3);
            %Exit early to prevent overwritting with next wave
            LegActive(i)=1;
%            break;
        end
        if LegActive(i)==0
            set(Leg(i),'Color','k','LineWidth',0.1);
        end
    end
    pause(0.1);
end
%Clean up animation stuff
if ishandle(timeBar)  %If these have not been cleared, clear them
    delete(timeBar);
    for i=1:numLegs
        delete(Leg(i));
    end
end


% --- Executes on slider movement.
function SpeedSlider_Callback(hObject, eventdata, handles)
% hObject    handle to SpeedSlider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider


% --- Executes during object creation, after setting all properties.
function SpeedSlider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to SpeedSlider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end





function PContr_Callback(hObject, eventdata, handles)
% hObject    handle to PC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of PC as text
%        str2double(get(hObject,'String')) returns contents of PC as a double


% --- Executes during object creation, after setting all properties.
function PContr_CreateFcn(hObject, eventdata, handles)
% hObject    handle to PC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


